SystemOrganization addCategory: #'Tp1-TADP'!
SystemOrganization addCategory: #'Tp1-TADP-Test'!

Trait named: #NoPoceado
	uses: {}
	category: 'Tp1-TADP'!

Trait named: #Poceado
	uses: {}
	category: 'Tp1-TADP'!

Object subclass: #Agencia
	instanceVariableNames: 'caja aPagar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-TADP'!

!Agencia methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 13:57'!
aPagar
	^ aPagar! !

!Agencia methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 14:04'!
aPagar: anObject
	aPagar add: anObject.! !

!Agencia methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 12:01'!
caja
	^ caja! !

!Agencia methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 12:01'!
caja: anObject
	caja := anObject! !

!Agencia methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 12:02'!
ganaste: plata 
	self caja: caja + plata.! !

!Agencia methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 14:03'!
initialize 
	self caja: 0.
	aPagar := OrderedCollection new..! !

!Agencia methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 14:09'!
pagale: pago
	self aPagar: pago.! !

Object subclass: #Apuesta
	instanceVariableNames: 'juego jugada agencia monto jugador'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-TADP'!

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:27'!
agencia
	^ agencia! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:27'!
agencia: anObject
	agencia := anObject! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:27'!
juego
	^ juego! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:27'!
juego: anObject
	juego := anObject! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:27'!
jugada
	^ jugada! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:27'!
jugada: anObject
	jugada := anObject! !

!Apuesta methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 14:08'!
jugador
	^ jugador! !

!Apuesta methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 14:08'!
jugador: anObject
	jugador := anObject! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:27'!
monto
	^ monto! !

!Apuesta methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:27'!
monto: anObject
	monto := anObject! !

!Apuesta methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 13:45'!
sosGanadora: jugadaGanadora 
	^self jugada allSatisfy:[:unNumero | jugada includes: unNumero].! !

Object subclass: #Juego
	instanceVariableNames: 'apuestasEnJuego'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-TADP'!

!Juego methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/6/2012 18:08'!
apuestasEnJuego
	^ apuestasEnJuego.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/6/2012 18:10'!
initialize 			
	apuestasEnJuego := OrderedCollection new.
		
		! !

!Juego methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/6/2012 18:08'!
recibiApuesta: apuesta
	self apuestasEnJuego add: apuesta! !

Juego subclass: #Loto
	uses: Poceado
	instanceVariableNames: 'pozo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-TADP'!

Loto class
	uses: Poceado classTrait
	instanceVariableNames: ''!

!Loto methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 13:01'!
pozo
	^ pozo! !

!Loto methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 13:01'!
pozo: anObject
	pozo := anObject! !

!Loto methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/7/2012 14:22'!
tomaGanadora: jugadaGanadora 
     | coleccionGanadores |

	self pozo: apuestasEnJuego size * 2.
	
	"Las agencias ganan el 12% de las jugadas realiadas en ellas"
	apuestasEnJuego do:[:ap | ap agencia ganaste: (ap monto*12/100)].  
	
	"coleccion de ganadores con 6 aciertos"	
	coleccionGanadores := apuestasEnJuego select:[:apuesta | apuesta sosGanadora: jugadaGanadora]. 
	
	"Le pago a la agencia el 5% y le digo que le page al timbero ganador el 40% del pozo (dividido la cantidad de ganadores)"
	coleccionGanadores do:[:apuestaG | (apuestaG agencia ganaste: ((pozo * 40 /100)/( coleccionGanadores size))*5/100 ). (apuestaG agencia aPagar: #(((pozo * 40 /100)/(coleccionGanadores size)) (apuestaG jugador)))].
	
	

! !

Juego subclass: #PagaOPaga
	uses: NoPoceado
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-TADP'!

PagaOPaga class
	uses: NoPoceado classTrait
	instanceVariableNames: ''!

Juego subclass: #Prode
	uses: Poceado
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-TADP'!

Prode class
	uses: Poceado classTrait
	instanceVariableNames: ''!

Juego subclass: #Quiniela
	uses: NoPoceado
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-TADP'!

Quiniela class
	uses: NoPoceado classTrait
	instanceVariableNames: ''!

Object subclass: #Sorteo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-TADP'!

!Sorteo methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/7/2012 12:05'!
initialize 
	apuestasLoto := OrderedCollection new.
	apuestasQuiniela  := OrderedCollection new.
	apuestasPoP  := OrderedCollection new.
	apuestasProde  := OrderedCollection new.
					! !

!Sorteo methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/7/2012 12:22'!
sorteame: jugadaGanadora alJuego: juego
	juego tomaGanadora: jugadaGanadora .! !

Object subclass: #Timbero
	instanceVariableNames: 'apuestas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-TADP'!

!Timbero methodsFor: 'accessing' stamp: 'pdanibenitez 9/6/2012 15:01'!
apuestas
	^ apuestas! !

!Timbero methodsFor: 'accessing' stamp: 'MarianoGerman 9/7/2012 14:08'!
armarApuestaDe: unJuego con: unaJugada para: unaAgencia con: unMonto
	| unaApuesta |
	
	unaApuesta := Apuesta new.
	unaApuesta juego: unJuego.
	unaApuesta jugada: unaJugada.
	unaApuesta agencia: unaAgencia.
	unaApuesta monto: unMonto.
	unaApuesta jugador: self.
	
	self apuestas add: unaApuesta.
	
	! !

!Timbero methodsFor: 'as yet unclassified' stamp: 'GuidoWagner 9/6/2012 17:43'!
initialize 
	super initialize. 
	apuestas := OrderedCollection new.


	! !

!Timbero methodsFor: 'accessing' stamp: 'GuidoWagner 9/6/2012 17:44'!
jugar
	self apuestas do:[ :apuesta | apuesta juego recibiApuesta: apuesta ].! !

TestCase subclass: #Testeador
	instanceVariableNames: 'bruno quini6 apostaConMarta apuesta loto quini pagaLaPutaMadre prodeGanaRiver agenciaPirulo jugada sorteo bruna altaJugada nano unaJugada otraJugada'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-TADP-Test'!

!Testeador methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/7/2012 14:23'!
testApuestaInicial
	agenciaPirulo := Agencia new.
	loto := Loto new.
	bruno := Timbero new.
	
	bruno initialize.
	loto initialize.
	agenciaPirulo initialize.
	
	bruno armarApuestaDe: loto con: #(4 8 15 16 23 42) para: agenciaPirulo con: 2.
	bruno jugar.
	
	sorteo := Sorteo new.
	sorteo initialize.
	sorteo sorteame: #(4 8 15 16 23 42) alJuego: loto.
	self assert: agenciaPirulo caja equals: ((2*12/100)+((2*40/100)*5/100))! !
